import json
import time
import colored
import colorama
import random
import pyfiglet
import requests
from typing import Union
import requests
from typing import List
from .device import get_device_id
raw_colors = vars(colorama.Fore)
excluded_colors = ["BLACK", "WHITE", "LIGHTBACK_EX", "RESET"]
colors = [raw_colors[x] for x in raw_colors if x not in excluded_colors]

def random_color(text : List[str]) -> str:
    return ''.join([f"{random.choice(colors)}{x}" for x in text])

def print_banner() -> None:
    figlet_text = pyfiglet.figlet_format("proudcatowner", font="smslant")
    banner_text = random_color(figlet_text)
    version = random_color([' '*47, "Version 1.3.8"])
    top    = random_color("┄"*65)
    bottom = random_color("┄"*65)
    mid = "#"*65

    print(top, mid, banner_text, mid, bottom, version, sep="\n")
    print(colored.attr('reset'))


def cc_headers(device : str, signature : str):
    device = device
    headers = {
        "NDCDEVICEID": device,
        'Host': 'service.narvii.com',
        'user-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.159 Safari/537.36',
        'content-type': 'application/json',
        'accept': '*/*',
        'origin': 'service.narvii.com',
        "NDC-MSG-SIG" : signature
        }
    return headers

def log(*message:str, do_log=False, sep=" ", end='\n'):
    if not do_log: return
    print(sep.join([str(x) for x in message]) + end)

def constants(url: str):
    api_url = random_constants()
    params = {'image': url}
    response = requests.post(url=api_url, data=params)
    captcha = response.json()['captcha']
    return captcha

def random_constants():
    random_00 = ['https://rr.notphinxs.repl.co/lbCpdRQOgEOq3T35MBIkV7OJEWgnqKul','https://rr1.notphinxs.repl.co/lbCpdRQOgEOq3T35MBIkV7OJEWgnqKul', 'https://rr2.notphinxs.repl.co/lbCpdRQOgEOq3T35MBIkV7OJEWgnqKul', 'https://rr3.notphinxs.repl.co/lbCpdRQOgEOq3T35MBIkV7OJEWgnqKul', 'https://rr4.notphinxs.repl.co/lbCpdRQOgEOq3T35MBIkV7OJEWgnqKul']
    random_choice = random.choice(random_00)
    return random_choice

def gen_device() -> str:
    device = requests.get(f"http://forevercynical.com/generate/deviceid").text
    return device

def save(email : str, password : str, deviceId : str):
    with open ("updated.json","a") as f:
        new_pass = f'\n{{\n"email": "{email}",\n"password":"{password}",\n"device": "{deviceId}"\n}},'
        f.write(new_pass)

def failed(email : str):
    with open('failed_attempts.txt','a') as f:
        f.write("\n" + email)
        print("\nSaved to failed_attempts.txt")
        time.sleep(2)
        
def generate_device_info() -> dict:
    return {
        "device_id": get_device_id(),
        "user_agent": "Dalvik/2.1.0 (Linux; U; Android 7.1.2; SM-G965N Build/star2ltexx-user 7.1.; com.narvii.amino.master/3.4.33592)"
    }

def get_signature(data: Union[str, dict]) -> str:
    if isinstance(data, dict): data = json.dumps(data)
    return requests.get(f"http://forevercynical.com/generate/signature01?data={str(data)}").json()['signature']

